/****************************************************************************
**
** Copyright (C) 1992-2008 Trolltech ASA. All rights reserved.
**
** This file is part of Qt Jambi.
**
** ** This file may be used under the terms of the GNU General Public
** License version 2.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of
** this file.  Please review the following information to ensure GNU
** General Public Licensing requirements will be met:
** http://www.trolltech.com/products/qt/opensource.html
**
** If you are unsure which license is appropriate for your use, please
** review the following information:
** http://www.trolltech.com/products/qt/licensing.html or contact the
** sales department at sales@trolltech.com.

**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

package com.trolltech.qt;

import com.trolltech.qt.core.*;

class QtJambi_LibraryShutdown implements Runnable {
    public void run() {
        QCoreApplication app = QCoreApplication.instance();

        if (QtJambi_LibraryInitializer.messageHandler != null)
            QMessageHandler.removeMessageHandler(QtJambi_LibraryInitializer.messageHandler);

        if (app != null) {
            Thread appThread = app.thread();
            QCoreApplication.quit();

            try {
                if (appThread != null)
                    appThread.join(500);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }

        run_helper();
    }

    private native void run_helper();

}
